#include <time.h>

#include "error.h"
#include "utils.h"
#include "sched.h"
#include "emit.h"

sched_t scheds[N_SCHED] = {
		{ SCHED_LOAD, 0, DI_LOAD },
		{ SCHED_TS, 0, DI_TS },
		{ SCHED_MEMINFO, 0, DI_MEMINFO },
		{ SCHED_UPTIME, 0, DI_UPTIME},
		{ SCHED_PROCINFO, 0, DI_PROCINFO }
	};

int main(int argc, char *argv[])
{
	char show_header = 1;

	for(;;)
	{
		int loop;
		char header_shown = 0;

		for(loop=0; loop<N_SCHED; loop++)
		{
			time_t now = time(NULL);
			time_t cur_next_event = scheds[loop].last_run + scheds[loop].interval;

			if (cur_next_event <= now)
			{
				if (!header_shown)
				{
					if (show_header)
						emit_ts();

					header_shown = 1;
				}

				switch(scheds[loop].what)
				{
					case SCHED_TS:
						emit_ts();
						break;

					case SCHED_LOAD:
						emit_load();
						break;

					case SCHED_MEMINFO:
						emit_meminfo();
						break;

					case SCHED_UPTIME:
						emit_n_users_and_uptime();
						break;

					case SCHED_PROCINFO:
						emit_proc_usage_and_mem_usage(scheds[loop].interval);
						break;

					default:
						error_exit("internal error: type %d unknown\n", scheds[loop].what);
				}

				scheds[loop].last_run = now;
			}
		}

		sleep_untill_next_event(scheds, N_SCHED);
	}

	return 0;
}
